       IDENTIFICATION DIVISION.
       PROGRAM-ID. TCSFUNC.
      *VERSION 1.2 of February 2005
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *                                             Function sequ table
           SELECT FUNC-FILE ASSIGN TO DYNAMIC FUNC-FILE-PAR
                  ORGANIZATION IS LINE SEQUENTIAL
                  FILE STATUS IS FNC-FSTS.
      *
      ******************************************************************
      *
       DATA DIVISION.
      *
       FILE SECTION.
      *
      ******************************************************************
      *
       FD  FUNC-FILE
           DATA RECORD IS FUNC-FILE-REC.
       01  FUNC-FILE-REC.
           05 FUNCTION-NR            PIC 9(4).
           05 FILLER                 PIC X.
           05 FUNCTION-LNG           PIC 99.
           05 FILLER                 PIC X.
           05 FUNCTION-TYPE          PIC X(4).
           05 FILLER                 PIC X.
           05 FUNCTION-NAME          PIC X(36).
           05 FILLER                 PIC X(31).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
       77  FUNC-FILE-PAR          PIC X(80).
       77  FNC-FSTS               PIC XX.
       77  INPUT-END              PIC 9 VALUE 0.
       77  FOUND-SW               PIC 9.
       77  NR-OBJECTS             PIC 9(4) VALUE ZERO.
       77  CONTINUE-KEY           PIC X.
      *
      *    Text data
      *
       77  FUNCTION-ERR-TXT       PIC X(80).
KATI  *                                 sort indexes
       01  INDEXES.
           05  S-I                      PIC 9(4) BINARY.
           05  S-J                      PIC 9(4) BINARY.
           05  MIN-I                    PIC 9(4) BINARY.
      *
      *    Search Data
      *
       01  SEARCH-DATA.
           02  J                       PIC 99.
           02  K                       PIC 99.
           02  STRING-LNG              PIC 99  VALUE 36.
           02  SEARCH-KEY-NAME         PIC X(36).
           02  KEY-STRING              PIC X(36).
           02  KEY-CHARS               REDEFINES KEY-STRING.
               03 KEY-CHAR             PIC X OCCURS 36 TIMES.
      *                           Loaded from the function sequ file
       01  FUNCTION-TABLE.
           02 I                        PIC 9(4) BINARY.
           02 NR-FUNCTIONS             PIC 9(4) BINARY.
SIZE       02 MAX-FNC-NR               PIC 9(4) BINARY VALUE 2400.
           02 WORK-FUNC-ENTRY          PIC X(36).
           02 FUNC-TABLE.
SIZE          03 FUNC-TAB              OCCURS 2400 TIMES.
                 04 FUNC-LNG           PIC 99.
                 04 FUNC-TYPE          PIC X(4).
                 04 FUNCTION-KEY       PIC X(36).
      *
       01  ERROR-RETURN-VALUES.
           02 ERR-1             PIC 9 VALUE 1.
           02 TXT-1             PIC X(36) VALUE
                       ' Open error on Function File : '.
           02 ERR-2             PIC 9 VALUE 2.
           02 TXT-2             PIC X(40) VALUE
                       ' Table size error in Function Table '.
           02 ERR-3             PIC 9 VALUE 3.
           02 TXT-3             PIC X(44) VALUE
                       ' Required name is not in the Function Table'.
           02 ERR-4             PIC 9 VALUE 4.
           02 TXT-4             PIC X(32) VALUE
                       ' Function Table Limit exceeded! '.
           02 ERR-5             PIC 9 VALUE 5.
           02 TXT-5             PIC X(32) VALUE
                       ' Object is already in the Table!'.
      *
      ******************************************************************
      *
       LINKAGE SECTION.
      *
      ******************************************************************
      *
           COPY FUNCPARS.
      *
      **************************************************************
      *
       01  FUNCTION-FILE-NAME         PIC X(80).
      *
      ******************************************************************
      *
       PROCEDURE DIVISION USING FUNCTION-IO-PARAMS FUNCTION-FILE-NAME.
      *
      ******************************************************************
      *
       FUNCTION-MAIN SECTION.
      *
           MOVE ZERO TO FUNCTION-RETC
           EVALUATE TRUE
             WHEN FUNCTION-IO-CODE = 'OPEN'
               MOVE ZERO TO NR-FUNCTIONS
               MOVE SPACES TO FUNC-TABLE
               MOVE ALL ZERO TO FNC-FSTS
               MOVE FUNCTION-FILE-NAME TO FUNC-FILE-PAR
               OPEN INPUT FUNC-FILE
               IF FNC-FSTS NOT = ALL ZEROS
                 MOVE ERR-1 TO FUNCTION-RETC
                 PERFORM ERROR-PROC
               END-IF
               PERFORM READ-FUNCTION-FILE
               CLOSE FUNC-FILE
             WHEN FUNCTION-IO-CODE = 'FIND'
               MOVE FUNCTION-IO-STRING TO SEARCH-KEY-NAME
               PERFORM SET-ACT-TAB-INDEX
             WHEN FUNCTION-IO-CODE = 'ADD '
PATCH          INSPECT FUNCTION-IO-STRING REPLACING ALL X'0C' BY ' '
PATCH          INSPECT FUNCTION-IO-STRING REPLACING ALL X'0D' BY ' '
               MOVE FUNCTION-IO-STRING TO SEARCH-KEY-NAME
               PERFORM ADD-ACT-TAB-INDEX
             WHEN FUNCTION-IO-CODE = 'CLOS'
               OPEN OUTPUT FUNC-FILE
               PERFORM WRITE-FUNCTION-FILE
               CLOSE FUNC-FILE
           END-EVALUATE
           EXIT PROGRAM.
      *
      ****************************************************************
       SUBROUTINES SECTION.
      ****************************************************************
      *
       READ-FUNCTION-FILE.
           MOVE ZERO TO INPUT-END
           MOVE ZERO TO NR-OBJECTS
           READ FUNC-FILE
             AT END MOVE 1 TO INPUT-END
           END-READ
           PERFORM UNTIL INPUT-END = 1
             ADD 1 TO NR-FUNCTIONS
             IF NR-FUNCTIONS > MAX-FNC-NR
               MOVE ERR-2 TO FUNCTION-RETC
               PERFORM ERROR-PROC
             END-IF
             MOVE FUNCTION-LNG  TO FUNC-LNG  (NR-FUNCTIONS)
             MOVE FUNCTION-TYPE TO FUNC-TYPE (NR-FUNCTIONS)
             MOVE FUNCTION-NAME TO FUNCTION-KEY (NR-FUNCTIONS)
SNEED        IF FUNCTION-TYPE = 'NOUN'
SNEED           ADD 1 TO NR-OBJECTS
SNEED        END-IF
             READ FUNC-FILE
               AT END MOVE 1 TO INPUT-END
             END-READ
           END-PERFORM.
           MOVE NR-OBJECTS TO FUNCTION-IO-LNG.
TEST***    PERFORM DISPLAY-TABLE-CONTENTS.
      ****************************************************************
      *
       SET-ACT-TAB-INDEX.
TEST***    DISPLAY 'Check Function:' SEARCH-KEY-NAME
TEST***    DISPLAY 'Function-Type :' FUNCTION-TYPE
TEST***    DISPLAY 'NR-OBJECTS:' NR-OBJECTS
TEST***    ACCEPT CONTINUE-KEY
           MOVE ZERO TO FOUND-SW.
           IF FUNCTION-IO-TYPE = 'NOUN' AND
              NR-OBJECTS = ZERO
              MOVE 1 TO FOUND-SW
              MOVE ZEROES TO FUNCTION-RETC
           ELSE
              MOVE 1 TO I
              PERFORM UNTIL I > NR-FUNCTIONS
                         OR I > MAX-FNC-NR
                         OR FOUND-SW = 1
                 MOVE FUNCTION-KEY (I) TO KEY-STRING
                 MOVE FUNC-LNG (I) TO J
SNEED            IF KEY-CHAR (J) = '-'
SNEED               SUBTRACT 1 FROM J
SNEED            END-IF
TEST***          DISPLAY 'Key String:' KEY-STRING (1:J)
TEST***          DISPLAY 'Search Key:' SEARCH-KEY-NAME (1:J)
TEST***          ACCEPT CONTINUE-KEY
SEPT07           IF FUNCTION-IO-TYPE = 'NOUN'
SEPT07              IF KEY-STRING = SEARCH-KEY-NAME
PATCH               OR KEY-STRING (1:3) = 'BO-'
SEPT07                 MOVE 1 TO FOUND-SW
SEPT07              ELSE
SEPT07                 ADD 1 TO I
SEPT07              END-IF
SEPT07           ELSE
SEPT07              IF KEY-STRING (1:J) = SEARCH-KEY-NAME (1:J)
SEPT07                 MOVE 1 TO FOUND-SW
SEPT07              ELSE
SEPT07                 ADD 1 TO I
SEPT07              END-IF
SEPT07           END-IF
              END-PERFORM
              IF FOUND-SW = 1
      *        the function name is in the table
                 MOVE FUNC-TYPE (I) TO FUNCTION-IO-TYPE
                 MOVE FUNC-LNG  (I) TO FUNCTION-IO-LNG
                 MOVE ZEROES TO FUNCTION-RETC
              ELSE
      *        the function name is not in the table
                 MOVE SPACES  TO FUNCTION-IO-TYPE
                 MOVE ZEROES  TO FUNCTION-IO-LNG
                 MOVE ERR-3 TO FUNCTION-RETC
                 PERFORM ERROR-PROC
              END-IF
           END-IF.
TEST***    DISPLAY 'Found_SW:' FOUND-SW
TEST***    ACCEPT CONTINUE-KEY.
      ****************************************************************
      *
       ADD-ACT-TAB-INDEX.
TEST***    DISPLAY 'Add Object:' SEARCH-KEY-NAME
TEST***    ACCEPT CONTINUE-KEY
           MOVE SEARCH-KEY-NAME TO KEY-STRING
           MOVE ZERO TO FOUND-SW
           MOVE 1 TO I
           PERFORM UNTIL I > NR-FUNCTIONS
                      OR I > MAX-FNC-NR
                      OR FOUND-SW = 1
             IF KEY-STRING  = FUNCTION-KEY (I)
                MOVE 1 TO FOUND-SW
             ELSE
                ADD 1 TO I
             END-IF
           END-PERFORM.
TEST***    DISPLAY 'Found_SW:' FOUND-SW
           IF FOUND-SW = 0  AND
              NR-FUNCTIONS < MAX-FNC-NR
      *        the function name is not in the table
              ADD 1 TO NR-FUNCTIONS
              MOVE KEY-STRING TO FUNCTION-KEY (NR-FUNCTIONS)
              MOVE FUNCTION-IO-TYPE TO FUNC-TYPE (NR-FUNCTIONS)
              MOVE 1 TO J
              PERFORM UNTIL KEY-CHAR (J) = SPACE
                         OR J > STRING-LNG
                 ADD 1 TO J
              END-PERFORM
              SUBTRACT 1 FROM J
              MOVE J TO FUNC-LNG  (NR-FUNCTIONS)
TEST***       DISPLAY 'NR-FUNCS=' NR-FUNCTIONS
TEST***       DISPLAY 'Object Added=' FUNCTION-KEY (NR-FUNCTIONS)
TEST***       DISPLAY 'Object Type =' FUNC-TYPE (NR-FUNCTIONS)
TEST***       DISPLAY 'Object Lng  =' FUNC-LNG  (NR-FUNCTIONS)
           ELSE
              MOVE SPACES  TO FUNCTION-IO-TYPE
              MOVE ZEROES  TO FUNCTION-IO-LNG
              MOVE ERR-5 TO FUNCTION-RETC
              PERFORM ERROR-PROC
           END-IF
           IF NR-FUNCTIONS > MAX-FNC-NR
              DISPLAY 'Function-Table Limit exceeded'
              DISPLAY 'Table Limit = ' MAX-FNC-NR
              DISPLAY 'Press Enter to Continue!'
              ACCEPT CONTINUE-KEY
           END-IF.
TEST***    ACCEPT CONTINUE-KEY.
      ****************************************************************
      *
       WRITE-FUNCTION-FILE.
SN1102     PERFORM SORT-PROC.
           MOVE 1 TO I
           PERFORM UNTIL I > NR-FUNCTIONS
             MOVE I TO FUNCTION-NR
             MOVE FUNC-LNG (I) TO FUNCTION-LNG
             MOVE FUNC-TYPE (I) TO FUNCTION-TYPE
             MOVE FUNCTION-KEY (I) TO FUNCTION-NAME
             WRITE FUNC-FILE-REC
             ADD 1 TO I
           END-PERFORM.
           EXIT.
      ****************************************************************
      *
       ERROR-PROC.
           EVALUATE TRUE
             WHEN FUNCTION-RETC = ERR-1
               STRING FUNCTION-FILE-NAME DELIMITED SPACE
                      TXT-1    DELIMITED SIZE
                      FNC-FSTS DELIMITED SIZE
                 INTO FUNCTION-ERR-TXT
             WHEN FUNCTION-RETC = ERR-2
               STRING FUNCTION-FILE-NAME DELIMITED SPACE
                      TXT-2              DELIMITED SIZE
                 INTO FUNCTION-ERR-TXT
             WHEN FUNCTION-RETC = ERR-3
               STRING FUNCTION-IO-STRING DELIMITED SPACE
                      TXT-3              DELIMITED SIZE
                 INTO FUNCTION-ERR-TXT
             WHEN FUNCTION-RETC = ERR-4
               STRING FUNCTION-IO-STRING DELIMITED SPACE
                      TXT-4              DELIMITED SIZE
                 INTO FUNCTION-ERR-TXT
             WHEN FUNCTION-RETC = ERR-5
               STRING FUNCTION-IO-STRING DELIMITED SPACE
                      TXT-5              DELIMITED SIZE
                 INTO FUNCTION-ERR-TXT
             WHEN OTHER
               CONTINUE
           END-EVALUATE
SNEED**    DISPLAY FUNCTION-ERR-TXT
SNEED**    ACCEPT CONTINUE-KEY
           EXIT PROGRAM.
      *
KATI  ******************************************************************
       SORT-OBJECTS SECTION.
      ******************************************************************
      *          Sort the function table into ascending order
      *
       SORT-PROC.
           MOVE 1 TO S-I
           PERFORM UNTIL FUNC-TYPE (S-I) = 'NOUN' OR S-I = NR-FUNCTIONS
              ADD 1 TO S-I
           END-PERFORM.
           PERFORM VARYING S-I FROM S-I BY 1 UNTIL S-I > NR-FUNCTIONS
             MOVE S-I TO MIN-I
             MOVE FUNCTION-KEY (S-I) TO WORK-FUNC-ENTRY
             COMPUTE S-J = S-I + 1
             PERFORM VARYING S-J FROM S-J BY 1 UNTIL S-J > NR-FUNCTIONS
               IF WORK-FUNC-ENTRY > FUNCTION-KEY (S-J)
                 MOVE FUNCTION-KEY (S-J) TO WORK-FUNC-ENTRY
                 MOVE S-J TO MIN-I
               END-IF
             END-PERFORM
             MOVE FUNC-TAB (S-I) TO FUNC-TAB (MIN-I)
             MOVE WORK-FUNC-ENTRY TO FUNCTION-KEY (S-I)
           END-PERFORM.
TEST***    PERFORM DISPLAY-TABLE-CONTENTS.
           EXIT.
      *****************************************************************
TEST   DISPLAY-TABLE-CONTENTS.
TEST       DISPLAY 'Sorted Object Table Contents!'
TEST       PERFORM VARYING I FROM 1 BY 1 UNTIL I > NR-FUNCTIONS
TEST          DISPLAY 'Func-Name-Lng:' FUNC-LNG (I)
TEST          DISPLAY 'Func-Name-Typ:' FUNC-TYPE (I)
TEST          DISPLAY 'Func-Name    :' FUNCTION-KEY (I)
TEST          ACCEPT CONTINUE-KEY
TEST       END-PERFORM.
      *                    end of TXTFUNC
      ******************************************************************
