       IDENTIFICATION DIVISION.
       PROGRAM-ID. TCSMESS.
      ******************************************************************
      *  PROGRAM NAME: TCSMESS  (SOFTANAL)                             *
      *  PURPOSE:      subprogram for producing a metric export file   *
      *                in XML format for further processing            *
      *                                                                *
      *  VERSION:      2.1 (03.2006)                                   *
      *                                                                *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      *                                                                *
      *  PROGRAM FUNCTIONS:                                            *
      *    - producing an XML header                                   *
      *    - write one introducing header record                       *
      *    - write 25 XML metric elements                              *
      ******************************************************************
      *
      *          S A M P L E    E X P O R T     F O R M A T
      *
      *<?xml version="1.0" encoding="UTF-8" ?>
      *<TCMETRIC>
      *  <METRIC_FILE Project = "GEOS"
      *               Product =  "FIVS"
      *               Source  =  "TCSANAL"
      *               Date    =  "05.10.02"
      *     <METRIC_ENTITY Entity = "System"
      *                    EName = "Telekurs"
      *                    EType = "CTF">
      *        <Quantity_Metrics>
      *           <Structural_Quantities>
      *              <Nr_Systems>9999999</Nr_Systems>
      *              <Nr_Modules>9999999</Nr_Modules>
      *              <Nr_Concepts>9999999<Nr_Concepts>
      *              <Nr_Requires>9999999<Nr_Requires>
      *              <Nr_UseCases>9999999<Nr_UseCases>
      *              <Nr_Objects>9999999<Nr_Objects>
      *              <Nr_Test_Requs>9999999</Nr_Test_Requs>
      *              <Nr_Test_Funcs>9999999</Nr_Test_Funcs>
      *              <Nr_Test_Objts>9999999</Nr_Test_Objts>
      *           </Structural_Quantities>
      *           <Test_Quantities>
      *              <Nr_TestProcs>9999999</Nr_TestProcs>
      *              <Nr_TestCases>9999999</Nr_TestCases>
      *              <Nr_Attributes>9999999</Nr_Attributes>
      *              <Nr_TestCase_Types>9999999</Nr_TestCase_Types>
      *              <Nr_TestCase_Srcs>9999999</Nr_TestCase_Srcs>
      *              <Nr_TestCase_Goals>9999999</Nr_TestCase_Goals>
      *              <Nr_TestCases_Auto>9999999</Nr_TestCases_Auto>
      *              <Nr_Pre_Conditions>9999999</Nr_Pre_Conditions>
      *              <Nr_Post_Conditions>9999999</Nr_Post_Conditions>
      *              <Nr_Test_Triggers>9999999</Nr_Test_Triggers>
      *              <Nr_Actions>9999999</Nr_Actions>
      *              <Nr_States>9999999</Nr_States>
      *              <Nr_Rules>9999999</Nr_Rules>
      *              <Nr_Others>9999999</Nr_Others>
      *           </Test_Quantities>
      *           <Data_Quantities>
      *              <Nr_Inputs>9999999</Nr_Inputs>
      *              <Nr_Outputs>9999999</Nr_Outputs>
      *              <Nr_Strings>9999999</Nr_Strings>
      *              <Nr_Numerics>9999999</Nr_Numerics>
      *              <Nr_Codes>9999999</Nr_Codes>
      *              <Nr_Booleans>9999999</Nr_Booleans>
      *              <Nr_Params>9999999</Nr_Params>
      *           </Data_Quantities>
      *           <Test_Deficiencies>
      *              <Nr_Major_Defis>9999999</Nr_Major_Defis>
      *              <Nr_Media_Defis>9999999</Nr_Media_Defis>
      *              <Nr_Minor_Defis>9999999</Nr_Minor_Defis>
      *              <Nr_Missing_Attrs>9999999</Nr_Missing_Attrs>
      *              <Nr_Missing_Refs>9999999</Nr_Missing_Refs>
      *           </Test_Deficiencies>
      *           <Size_Metrics>
      *              <Nr_Test_Points>9999999</Nr_Test_Points>
      *              <Nr_Data_Points>9999999</Nr_Data_Points>
      *              <Nr_Func_Points>9999999</Nr_Func_Points>
      *           </Size_Metrics>
      *        </Quantities>
      *        <Complexities>
      *           <Data_Complexity>9.999</Data_Complexity>
      *           <Test_Intensity>9.999</Test_Intensity>
      *           <Test_Volumne>9.999</Test_Volumne>
      *           <Test_Density>9.999</Test_Density>
      *           <Test_Complexity>9.999</Test_Complexity>
      *        </Complexities>
      *        <Qualities>
      *           <Maintainability>9.999</Maintainability>
      *           <Flexibility>9.999</Flexibility>
      *           <Reusability>9.999</Reusability>
      *           <Conformity>9.999</Conformity>
      *           <Test_Quality>9.999</Test_Quality>
      *        /Qualities>
      *     </METRIC_ENTITY>
      *  ........................
      *  </METRIC_FILE>
      *</TCMETRIC>
      *
      ******************************************************************
      *
      *AUTHOR. SNEED.
      *INSTALLATION. Vienna.
      *DATE-WRITTEN. Okt. 2002.
      *
      ******************************************************************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. PC.
       OBJECT-COMPUTER. PC.
      *
      ******************************************************************
      *
       INPUT-OUTPUT SECTION.
      ******************************************************************
       FILE-CONTROL.
      ******************************************************************
      *
      * MESS audit  output file
      *
           SELECT  MESS-FILE
                   ASSIGN TO DYNAMIC MESS-FILE-NAME
                   ORGANISATION LINE SEQUENTIAL
                   ACCESS SEQUENTIAL
                   FILE STATUS IS MESS-FSTS.
      *
       I-O-CONTROL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
       FD  MESS-FILE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS MESS-REC.
      *
       01  MESS-REC             PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
       77  MESS-FILE-NAME               PIC X(80).
       77  CONTINUE-KEY                 PIC X.
       01  MESS-FSTS-X.
           05  MESS-FSTS                PIC X(02).
           05  FILLER                   PIC X(01)  VALUE '#'.
      *
       01  LOCAL-INDEXES.
           05  I                        PIC 99  VALUE ZERO.
           05  J                        PIC 99  VALUE ZERO.
           05  K                        PIC 99  VALUE ZERO.
      *
       01  LOCAL-VARIABLES.
           05  YYMMDD.
               10  YY                   PIC 99.
               10  MM                   PIC 99.
               10  DD                   PIC 99.
           05  DATUM.
               10  TAG                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  MON                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  JAHR                 PIC 99.
           05  TEST-POINTS              PIC 999999 VALUE ZERO.
           05  DATA-POINTS              PIC 999999 VALUE ZERO.
           05  FUNC-POINTS              PIC 999999 VALUE ZERO.
           05  WEIGHTED-DEFI-NR         PIC 999999 VALUE ZERO.
           05  CASE-AVERAGE             PIC 999999 VALUE ZERO.
           05  PARM-AVERAGE             PIC 999999 VALUE ZERO.
           05  COMP-SUM                 PIC 9V999  VALUE ZERO.
           05  QUAL-SUM                 PIC 9V999  VALUE ZERO.
           05  DATA-COMPLEXITY          PIC 9V999  VALUE ZERO.
           05  DENSITY                  PIC 9V999  VALUE ZERO.
           05  INTENSITY                PIC 9V999  VALUE ZERO.
           05  VOLUMNE                  PIC 9V999  VALUE ZERO.
           05  TEST-COMPLEXITY          PIC 9V999  VALUE ZERO.
           05  COVERAGE                 PIC 9V999  VALUE ZERO.
           05  MAINTAINABILITY          PIC 9V999  VALUE ZERO.
           05  REUSABILITY              PIC 9V999  VALUE ZERO.
           05  CONFORMITY               PIC 9V999  VALUE ZERO.
           05  TEST-QUALITY             PIC 9V999  VALUE ZERO.
           05  THIS-VALUE               PIC S9V999 VALUE ZERO.
           05  DISPLAY-VALUE            PIC ZZZZZ99 VALUE ZERO.
           05  RATIO-VALUE              PIC 9.999  VALUE ZERO.
           05  CURRENT-TAG              PIC X(20)  VALUE SPACES.
           05  CURRENT-VALUE            PIC X(7)   VALUE SPACES.
           05  CURRENT-ATTR             PIC X(12)  VALUE SPACES.
      *
      ****************************************************************
      *    METRIC EXPORT TAGS
      ****************************************************************
      *
       01  XML-HEADER-LINES.
           05  XML-LINE             PIC X(72) VALUE
              '<?xml version="1.0" encoding="UTF-8" ?>'.
           05  DOC-LINE             PIC X(72) VALUE
              '<!--DOCTYPE TCMETRIC SYSTEM "tcmetric.xsd"-->'.
       01  METRIK-EXPORT-TAGS.
           05  FILE-TAGS.
               10  METRIC-TAG       PIC X(20) VALUE 'METRIC_FILE'.
               10  PRODUCT-ATTR     PIC X(20) VALUE 'Product'.
               10  SYSTEM-ATTR      PIC X(20) VALUE 'System'.
               10  SENDER-ATTR      PIC X(20) VALUE 'Source '.
               10  DATE-ATTR        PIC X(20) VALUE 'Date   '.
           05  ENTITY-TAGS.
               10  ENTITY-TAG       PIC X(20) VALUE 'METRIC_ENTITY'.
               10  ENTITY-ATTR      PIC X(20) VALUE 'Entity'.
               10  NAME-ATTR        PIC X(20) VALUE 'EName'.
               10  TYPE-ATTR        PIC X(20) VALUE 'EType'.
           05  STRUCTURE-TAGS.
               10  QUANTITY-TAG     PIC X(20) VALUE 'Quantity_Metrics'.
               10  STRUCTURE-TAG   PIC X(20) VALUE 'Structural_Metrics'.
               10  TEST-TAG         PIC X(20) VALUE 'Test_Metrics'.
               10  DATA-TAG         PIC X(20) VALUE 'Data_Metrics'.
               10  DEFI-TAG        PIC X(20) VALUE 'Deficiency_Metrics'.
               10  SIZE-TAG         PIC X(20) VALUE 'Size_Metrics'.
               10  COMPLEXITY-TAG  PIC X(20) VALUE 'Complexity_Metrics'.
               10  COMPLEXITIES-TAG PIC X(20) VALUE 'Complexities'.
               10  QUALITY-TAG      PIC X(20) VALUE 'Quality_Metrics'.
               10  QUALITIES-TAG    PIC X(20) VALUE 'Qualities'.
           05  QUANTITY-TAGS.
               10  SYSTEM-TAG       PIC X(20) VALUE 'Nr_Systems'.
               10  MODULE-TAG       PIC X(20) VALUE 'Nr_Modules'.
               10  CONCEPT-TAG      PIC X(20) VALUE 'Nr_Concepts'.
               10  REQUIRE-TAG      PIC X(20) VALUE 'Nr_Requires'.
               10  USECASE-TAG      PIC X(20) VALUE 'Nr_UseCases'.
               10  OBJECT-TAG       PIC X(20) VALUE 'Nr_Objects'.
               10  TESTED-REQU-TAG  PIC X(20) VALUE 'Nr_Tested_Requs'.
               10  TESTED-FUNC-TAG  PIC X(20) VALUE 'Nr_Tested_Funcs'.
               10  TESTED-OBJT-TAG  PIC X(20) VALUE 'Nr_Tested_Objects'.
               10  TESTPROC-TAG     PIC X(20) VALUE 'Nr_TestProcs'.
               10  TESTCASE-TAG     PIC X(20) VALUE 'Nr_TestCases'.
               10  TESTATTR-TAG     PIC X(20) VALUE 'Nr_Attributes'.
               10  TESTTYPE-TAG     PIC X(20) VALUE 'Nr_TestCase_Types'.
               10  TESTSRC-TAG      PIC X(20) VALUE 'Nr_TestCase_Srcs'.
               10  TESTGOAL-TAG     PIC X(20) VALUE 'Nr_TestCase_Goals'.
               10  TESTAUTO-TAG     PIC X(20) VALUE 'Nr_TestCases_Auto'.
               10  PRE-COND-TAG     PIC X(20) VALUE 'Nr_Pre_Conditions'.
               10  POST-COND-TAG   PIC X(20) VALUE 'Nr_Post_Conditions'.
               10  TRIGGER-TAG      PIC X(20) VALUE 'Nr_Test_Triggers'.
               10  ACTIONS-TAG      PIC X(20) VALUE 'Nr_Actions'.
               10  STATES-TAG       PIC X(20) VALUE 'Nr_States'.
               10  RULES-TAG        PIC X(20) VALUE 'Nr_Rules'.
               10  OTHERS-TAG       PIC X(20) VALUE 'Nr_Others'.
               10  INPUTS-TAG       PIC X(20) VALUE 'Nr_Inputs'.
               10  OUTPUTS-TAG      PIC X(20) VALUE 'Nr_Outputs'.
               10  STRINGS-TAG      PIC X(20) VALUE 'Nr_Strings'.
               10  NUMERICS-TAG     PIC X(20) VALUE 'Nr_Numerics'.
               10  CODES-TAG        PIC X(20) VALUE 'Nr_Codes'.
               10  BOOLEANS-TAG     PIC X(20) VALUE 'Nr_Booleans'.
               10  PARAMS-TAG       PIC X(20) VALUE 'Nr_Params'.
               10  MAJORDEFI-TAG    PIC X(20) VALUE 'Nr_Major_Defis'.
               10  MEDIADEFI-TAG    PIC X(20) VALUE 'Nr_Media_Defis'.
               10  MINORDEFI-TAG    PIC X(20) VALUE 'Nr_Minor_Defis'.
               10  MISSING-ATTR-TAG PIC X(20) VALUE 'Nr_Missing_Attrs'.
               10  MISSING-REFS-TAG PIC X(20) VALUE 'Nr_Missing_Refs'.
               10  TESTPOINT-TAG    PIC X(20) VALUE 'Nr_Test_Points'.
               10  DATAPOINT-TAG    PIC X(20) VALUE 'Nr_Data_Points'.
               10  FUNCPOINT-TAG    PIC X(20) VALUE 'Nr_Func_Points'.
           05  COMPLEXITY-TAGS.
               10  DATA-COMP-TAG    PIC X(20) VALUE 'Data_Complexity'.
               10  DENSITY-TAG      PIC X(20) VALUE 'Test_Density'.
               10  INTENSITY-TAG    PIC X(20) VALUE 'Test_Intensity'.
               10  VOLUMNE-TAG      PIC X(20) VALUE 'Test_Volumne'.
               10  TESTCOMP-TAG     PIC X(20) VALUE 'Test_Complexity'.
           05  OUALITY-TAGS.
               10  MAINTAIN-TAG  PIC X(20) VALUE 'Test_Maintainability'.
               10  REUSE-TAG        PIC X(20) VALUE 'Test_Reusability'.
               10  COVERAGE-TAG     PIC X(20) VALUE 'Test_Coverage'.
               10  CONFORM-TAG      PIC X(20) VALUE 'Test_Conformity'.
               10  TESTQUAL-TAG     PIC X(20) VALUE 'Test_Quality'.
      *
      ****************************************************************
      *
       LINKAGE SECTION.
      *
      ******************************************************************
      * "Dynamic linkage file names" (and others)
      ******************************************************************
      *
       77  FUNCT-CODE                        PIC XX.
       77  RET-CODE                          PIC XX.
       77  FILE-NAME                         PIC X(80).
       01  EXPORT-DATA.
           05  PRODUCT-NAME                  PIC X(8).
           05  EXPORT-NAME                   PIC X(8).
           05  EXPORT-TYPE                   PIC X(8).
           05  EXPORTEUR                     PIC X(8).
           05  ENTITY-TYPE                   PIC X(8).
           05  ENTITY-LANG                   PIC X(8).
           05  ENTITY-NAME                   PIC X(12).
      ******************************************************************
      *    Basic Measurements Required
      ******************************************************************
      *
           COPY TMETPARS.
      *
           COPY TMETTAB.
      *
      ******************************************************************
      *
       PROCEDURE DIVISION USING FUNCT-CODE,
                                RET-CODE,
                                FILE-NAME,
                                EXPORT-DATA,
                                METR-TAB,
                                METRIC-TAB.
      *
      ******************************************************************
      *
       SOFTMESS-MAIN SECTION.
      *
      ******************************************************************
      *
      * Produce the metric export file for PC-MESS
      *
      ******************************************************************
       SOFTMESS-CONTROL.
      *
TEST***    DISPLAY 'TcsMess Funct-Code= ' FUNCT-CODE
TEST***    DISPLAY 'Export  File = ' FILE-NAME
TEST***    ACCEPT CONTINUE-KEY.
           MOVE ZEROS TO RET-CODE.
      *
           EVALUATE FUNCT-CODE
              WHEN 'WR'
                PERFORM OPEN-METRIC-EXPORT
                PERFORM SOFTMESS-CALCULATION
                PERFORM WRITE-ENTITY-HEADER
                PERFORM WRITE-ENTITY-METRICS
                PERFORM WRITE-ENTITY-END
                PERFORM CLOSE-MESS-FILE
              WHEN OTHER
                MOVE 11 TO RET-CODE
           END-EVALUATE.
      *
           GOBACK.
      *
      ******************************************************************
      *
       SOFTMESS-OUTPUT SECTION.
      *
      ******************************************************************
      *
       OPEN-METRIC-EXPORT.
      *
      ******************************************************************
      *
      *  Open the Export File
      *
      ******************************************************************
      *
           MOVE FILE-NAME TO MESS-FILE-NAME
           MOVE ZEROES TO MESS-FSTS
           OPEN OUTPUT MESS-FILE
           DISPLAY '| TCSMESS Version 2.1 of Mar. 2006 '
           DISPLAY '| SoftMess Export File  = ' MESS-FILE-NAME
           PERFORM WRITE-FILE-HEADER.
           EXIT.
      *
      ************************
      *
       WRITE-FILE-HEADER.
      *
      ******************************************************************
      *
      *  Create Metric Header
      *
      ******************************************************************
      *
      *                               Set up Header Info
      *
           MOVE XML-LINE TO MESS-REC
           WRITE MESS-REC.
           MOVE DOC-LINE TO MESS-REC
           WRITE MESS-REC.
           MOVE 'TCMETRIC' TO CURRENT-TAG.
           PERFORM WRITE-FIRST-LEVEL-START.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE PRODUCT-ATTR TO CURRENT-TAG
           MOVE PRODUCT-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SYSTEM-ATTR TO CURRENT-TAG
           MOVE EXPORT-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           ACCEPT YYMMDD FROM DATE
           MOVE YY TO JAHR
           MOVE MM TO MON
           MOVE DD TO TAG
           MOVE DATE-ATTR TO CURRENT-TAG
           MOVE DATUM TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SENDER-ATTR TO CURRENT-TAG
           MOVE EXPORTEUR TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-FILE-HEADER-END.
      *
      ******************************************************************
      *
       WRITE-ENTITY-HEADER.
      *
      ******************************************************************
      *
      *  Write out Entity Header
      *
      ******************************************************************
      *
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE ENTITY-TYPE TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE ENTITY-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE ENTITY-LANG TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-END.
      *
      ******************************************************************
      *
       WRITE-ENTITY-METRICS.
      *
      ******************************************************************
      *
      *  Write out all Entity Metrics
      *
      ******************************************************************
      ******************************************* Start of Quantity
           MOVE QUANTITY-TAG      TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Structural Metrics
           MOVE STRUCTURE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE SYSTEM-TAG        TO CURRENT-TAG
150308     MOVE 1                 TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE MODULE-TAG        TO CURRENT-TAG
           MOVE NR-MODULES        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE CONCEPT-TAG       TO CURRENT-TAG
           MOVE NR-CONCEPTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE REQUIRE-TAG       TO CURRENT-TAG
           MOVE NR-TARGET-REQUS   TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE USECASE-TAG       TO CURRENT-TAG
           MOVE NR-TARGET-FUNCS   TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE OBJECT-TAG        TO CURRENT-TAG
           MOVE NR-TARGET-OBJECTS TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTED-REQU-TAG   TO CURRENT-TAG
           MOVE NR-TESTED-REQUS   TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTED-FUNC-TAG   TO CURRENT-TAG
           MOVE NR-TESTED-FUNCS   TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTED-OBJT-TAG   TO CURRENT-TAG
           MOVE NR-TESTED-OBJECTS TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE STRUCTURE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Test  Metrics
           MOVE TEST-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE TESTPROC-TAG      TO CURRENT-TAG
           MOVE NR-TEST-PROCS     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTCASE-TAG      TO CURRENT-TAG
           MOVE NR-TEST-CASES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTATTR-TAG      TO CURRENT-TAG
           MOVE NR-TEST-ATTRS     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTTYPE-TAG      TO CURRENT-TAG
           MOVE NR-TEST-CASE-TYPES TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTSRC-TAG       TO CURRENT-TAG
           MOVE NR-TEST-CASE-SRCS  TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTGOAL-TAG      TO CURRENT-TAG
           MOVE NR-TEST-CASE-GOALS TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TESTAUTO-TAG      TO CURRENT-TAG
           MOVE NR-TEST-CASES-AUTO TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE PRE-COND-TAG      TO CURRENT-TAG
           MOVE NR-PRE-CONDS      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE POST-COND-TAG     TO CURRENT-TAG
           MOVE NR-POST-CONDS     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TRIGGER-TAG       TO CURRENT-TAG
           MOVE NR-TEST-TRIGGERS  TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE ACTIONS-TAG       TO CURRENT-TAG
           MOVE NR-ACTIONS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE STATES-TAG        TO CURRENT-TAG
           MOVE NR-STATES         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE RULES-TAG         TO CURRENT-TAG
           MOVE NR-RULES          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE OTHERS-TAG        TO CURRENT-TAG
           MOVE NR-OTHERS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE TEST-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Data  Metrics
           MOVE DATA-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE INPUTS-TAG        TO CURRENT-TAG
           MOVE NR-INPUTS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE OUTPUTS-TAG       TO CURRENT-TAG
           MOVE NR-OUTPUTS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE PARAMS-TAG        TO CURRENT-TAG
           MOVE NR-PARAMS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE STRINGS-TAG       TO CURRENT-TAG
           MOVE NR-STRINGS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE NUMERICS-TAG      TO CURRENT-TAG
           MOVE NR-NUMERICS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE CODES-TAG         TO CURRENT-TAG
           MOVE NR-CODES          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE BOOLEANS-TAG      TO CURRENT-TAG
           MOVE NR-BOOLEANS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE PARAMS-TAG        TO CURRENT-TAG
           MOVE NR-PARAMS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DATA-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Deficiency Metrics
           MOVE DEFI-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE MAJORDEFI-TAG     TO CURRENT-TAG
           MOVE NR-MAJOR-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE MEDIADEFI-TAG     TO CURRENT-TAG
           MOVE NR-MEDIA-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE MINORDEFI-TAG     TO CURRENT-TAG
           MOVE NR-MINOR-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DEFI-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Size Metrics
           MOVE SIZE-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE TESTPOINT-TAG     TO CURRENT-TAG
           MOVE TEST-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DATAPOINT-TAG     TO CURRENT-TAG
           MOVE DATA-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE FUNCPOINT-TAG     TO CURRENT-TAG
           MOVE FUNC-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE SIZE-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Quantity
           MOVE QUANTITY-TAG      TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ******************************************* Start of Complexity
           MOVE COMPLEXITY-TAG    TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Complexity Metrics
           MOVE COMPLEXITIES-TAG  TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE DATA-COMP-TAG     TO CURRENT-TAG
           MOVE DATA-COMPLEXITY   TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE DENSITY-TAG       TO CURRENT-TAG
           MOVE DENSITY           TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE INTENSITY-TAG     TO CURRENT-TAG
           MOVE INTENSITY         TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE VOLUMNE-TAG       TO CURRENT-TAG
           MOVE VOLUMNE           TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE TESTCOMP-TAG      TO CURRENT-TAG
           MOVE TEST-COMPLEXITY   TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE COMPLEXITIES-TAG  TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Complexity
           MOVE COMPLEXITY-TAG    TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ******************************************* Start of Quality
           MOVE QUALITY-TAG       TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Quality Metrics
           MOVE QUALITIES-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
           MOVE MAINTAIN-TAG      TO CURRENT-TAG
           MOVE MAINTAINABILITY   TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE REUSE-TAG         TO CURRENT-TAG
           MOVE REUSABILITY       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE COVERAGE-TAG      TO CURRENT-TAG
           MOVE COVERAGE          TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE CONFORM-TAG       TO CURRENT-TAG
           MOVE CONFORMITY        TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE TESTQUAL-TAG      TO CURRENT-TAG
           MOVE TEST-QUALITY      TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE QUALITIES-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Quality
           MOVE QUALITY-TAG       TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ************************************************ End of Entity
      *
       WRITE-ENTITY-END.
      *
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
      *
      ******************************************************************
      *
       CLOSE-MESS-FILE.
      *
      ******************************************************************
      *
      *  Close the Export File
      *
      ******************************************************************
      *
           MOVE 'TCMETRIC' TO CURRENT-TAG
           PERFORM WRITE-FIRST-LEVEL-END.
           CLOSE  MESS-FILE.
      ****************************************************************
       WRITE-XML SECTION.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING ' <'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING ' </'             DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '   <'            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR-END.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '">'              DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '   </'           DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-FILE-HEADER-END.
           MOVE SPACES TO MESS-REC.
           MOVE   '   />'  TO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '     <'          DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-ATTR.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '     </'         DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 4th Level
       WRITE-FOURTH-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '       <'        DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 4th Level
       WRITE-FOURTH-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '       </'       DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 5th Level
       WRITE-FIFTH-LEVEL-DATA.
           MOVE SPACES TO MESS-REC.
           STRING '         <'      DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
                   CURRENT-VALUE    DELIMITED BY SIZE
                  '</'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 5th Level
       WRITE-FIFTH-LEVEL-RATIO.
           MOVE SPACES TO MESS-REC.
           STRING '         <'      DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
                   CURRENT-VALUE    DELIMITED BY SPACE
                  '</'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      *
      *****************************************************************
      *
           COPY TMETCALC.
      *
      ******************* End of Source ********************************
