       IDENTIFICATION DIVISION.
       PROGRAM-ID. XINTMESS.
      ******************************************************************
      *  PROGRAM NAME: XINTMESS (SOFAUDIT)                             *
      *  PURPOSE:      subprogram for producing a metric export file   *
      *                in XML format for further processing            *
      *                                                                *
      *  VERSION:      3.2 (07.2007)                                   *
      *                                                                *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      *                                                                *
      *  PROGRAM FUNCTIONS:                                            *
      *    - producing an XML header                                   *
      *    - write one introducing header record                       *
      *    - write 56 XML metric elements                              *
      ******************************************************************
      *
      *          S A M P L E    E X P O R T     F O R M A T
      *
      *<?xml version="1.0" encoding="UTF-8" ?>
      *<!DOCTYPE IMETRICS SYSTEM "imetrics.xsd">
      *<IMETRICS>
      *  <METRIC_FILE Product = "GEOS"
      *               System =  "FIVS"
      *               Source =  "CPPANAL"
      *               Date   =  "05.10.02"
      *     <METRIC_ENTITY Entity = "Program"
      *                    EName = "Telekurs"
      *                    EType = "CPP">
      *        <Quantity_Metrics>
      *           <Source_Quantities>
      *              <Nr_Sources>9999999</Nr_Sources>
      *              <Nr_Lines>9999999</Nr_Lines>
      *              <Nr_Comment_Lines>9999999</Nr_Comment_Lines>
      *              <Nr-Empty_Lines>9999999</Nr_Empty_Lines>
      *              <Nr_Code_Lines>9999999</Nr_Code_Lines>
      *           </Source_Quantities>
      *           <Structural_Quantities>
      *              <Nr_Modules>9999999</Nr_Modules>
      *              <Nr_Files>9999999</Nr_Files>
      *              <Nr_Panels>9999999</Nr_Panels>
      *              <Nr_Reports>9999999</Nr_Reports>
      *              <Nr_Includes>9999999</Nr_Includes>
      *              <Nr_Classes>9999999</Nr_Classes>
      *              <Nr_Classes_Inherited>9999999</Nr_Classes_Inherited>
      *              <Nr_Methods>9999999</Nr_Methods>
      *              <Nr_Methods_Overriden>9999999<Nr_Methods_Overriden>
      *              <Nr_Procedures>9999999<Nr_Procedures>
      *              <Nr_Interfaces>9999999<Nr_Interfaces>
      *              <Nr_Function_Calls>9999999<Nr_Function_Calls
      *              <Nr_Foreign_Calls>9999999<Nr_Foreign_Calls
      *              <Nr_Functions>9999999<Nr_Functions>
      *              <Nr_Macros>9999999<Nr_Macro>
      *              <Nr_Macro_Refs>9999999<Nr_Macro_Refs>
      *              <Nr_TestCases>9999999</Nr_TestCases>
      *           </Structural_Quantities>
      *           <Data_Quantities>
      *              <Nr_Structures>9999999</Nr_Structures>
      *              <Nr_Defines>9999999</Nr_Defines>
      *              <Nr_Variables>9999999</Nr_Variables>
      *              <Nr_Constants>9999999</Nr_Constants>
      *              <Nr_Externals>9999999</Nr_Externals>
      *              <Nr_Structures>9999999</Nr_Structures>
      *              <Nr_Redefines>9999999</Nr_Redefines>
      *              <Nr_Arrays>9999999</Nr_Arrays>
      *              <Nr_Data_Inherited>9999999</Nr_Data_Inherited>
      *              <Nr_Data_Types>9999999</Nr_Data_Types>
      *           </Data_Quantities>
      *           <DataUsage_Quantities>
      *              <Nr_Arguments>9999999</Nr_Arguments>
      *              <Nr_Results>9999999</Nr_Results>
      *              <Nr_Predicates>9999999</Nr_Predicates>
      *              <Nr_Parameters>9999999</Nr_Parameters>
      *              <Nr_References>9999999</Nr_References>
      *           </DataUsage_Quantities>
      *           <Procedural_Quantities>
      *              <Nr_Stmts>9999999</Nr_Stmts>
      *              <Nr_Ifs>9999999</Nr_Ifs>
      *              <Nr_Switches>9999999</Nr_Switches>
      *              <Nr_Cases>9999999</Nr_Cases>
      *              <Nr_Loops>9999999</Nr_Loops>
      *              <Nr_GoTos>9999999</Nr_GoTos>
      *              <Nr_Returns>9999999</Nr_Returns>
      *              <Nr_Decisions>9999999</Nr_Decisions>
      *              <Nr_Literals>9999999</Nr_Literals>
      *              <Nr_Asserts>9999999</Nr_Asserts>
      *              <Nr_Branches>9999999</Nr_Branches>
      *              <Nr_Levels>9999999</Nr_Levels>
      *              <Nr_Stmt_Types>9999999</Nr_Stmt_Types>
      *           </Procedural_Quantities>
      *           <Interface_Quantities>
      *              <Nr_Panels>9999999</Nr_Panels>
      *              <Nr_Reports>9999999</Nr_Reports>
      *              <Nr_Files>9999999</Nr_Files>
      *              <Nr_DBs>9999999</Nr_DBs>
      *              <Nr_Inputs>9999999</Nr_Inputs>
      *              <Nr_Outputs>9999999</Nr_Outputs>
      *              <Nr_Accesses>9999999</Nr_Accesses>
      *              <Nr_Views>9999999</Nr_Views>
      *              <Nr_Interfaces>9999999</Nr_Interfaces>
      *           </Interface_Quantities>
      *           <Code_Deficiencies>
      *              <Nr_Major_Defis>9999999</Nr_Major_Defis>
      *              <Nr_Media_Defis>9999999</Nr_Media_Defis>
      *              <Nr_Minor_Defis>9999999</Nr_Minor_Defis>
      *           </Code_Deficiencies>
      *           <Size_Metrics>
      *              <Nr_Data_Points>9999999</Nr_Data_Points>
      *              <Nr_Objt_Points>9999999</Nr_Objt_Points>
      *              <Nr_Func_Points>9999999</Nr_Func_Points>
      *           </Size_Metrics>
      *        </Quantities>
      *        <Complexities>
      *           <Density_Complexity>9.999</Density_Complexity>
      *           <Relational_Complexity>9.999</Relational_Complexity>
      *           <Format_Complexity>9.999</Format_Complexity>
      *           <Structural_Complexity>9.999</Structural_Complexity>
      *           <ControlFlow_Complexity>9.999</ControlFlow_Complexity>
      *           <Language_Complexity>9.999</Language_Complexity>
      *           <Interface_Complexity>9.999</Interface_Complexity>
      *        </Complexities>
      *        <Qualities>
      *           <Usability>9.999</Usability>
      *           <Adaptability>9.999</Adaptability>
      *           <Reusablity>9.999</Reusability>
      *           <Testability>9.999</Testability>
      *           <Portablity>9.999</Portability>
      *           <Conformity>9.999</Conformity>
      *           <Interface_Quality>9.999</Interface_Quality>
      *        /Qualities>
      *     </METRIC_ENTITY>
      *  ........................
      *  </METRIC_FILE>
      *</IMETRICS>
      *
      ******************************************************************
      *
      *AUTHOR. SNEED.
      *INSTALLATION. Magdeburg.
      *DATE-WRITTEN. Okt. 2002.
      *
      ******************************************************************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. PC.
       OBJECT-COMPUTER. PC.
      *
      ******************************************************************
      *
       INPUT-OUTPUT SECTION.
      ******************************************************************
       FILE-CONTROL.
      ******************************************************************
      *
      * MESS audit  output file
      *
           SELECT  MESS-FILE
                   ASSIGN TO DYNAMIC MESS-FILE-NAME
                   ORGANISATION LINE SEQUENTIAL
                   ACCESS SEQUENTIAL
                   FILE STATUS IS MESS-FSTS.
      *
       I-O-CONTROL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
       FD  MESS-FILE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS MESS-REC.
      *
       01  MESS-REC             PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
       77  MESS-FILE-NAME               PIC X(80).
       01  MESS-FSTS-X.
           05  MESS-FSTS                PIC X(02).
           05  FILLER                   PIC X(01)  VALUE '#'.
      *
       01  LOCAL-INDEXES.
           05  I                        PIC 99  VALUE ZERO.
           05  J                        PIC 99  VALUE ZERO.
           05  K                        PIC 99  VALUE ZERO.
      *
       01  LOCAL-VARIABLES.
           05  YYMMDD.
               10  YY                   PIC 99.
               10  MM                   PIC 99.
               10  DD                   PIC 99.
           05  DATUM.
               10  TAG                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  MON                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  JAHR                 PIC 99.
           05  DISPLAY-VALUE            PIC ZZZZZZ9 VALUE ZERO.
           05  CURRENT-VALUE            PIC X(7)   VALUE SPACES.
           05  CURRENT-TAG              PIC X(20)  VALUE SPACES.
           05  CURRENT-ATTR             PIC X(12)  VALUE SPACES.
           05  WORK-METRICS.
               10  DEFI-NR              PIC 9999999 VALUE ZERO.
               10  CONSTANT-NR          PIC 9999999 VALUE ZERO.
               10  OPERAND-NR           PIC 9999999 VALUE ZERO.
               10  CYCLOMATIC-NR        PIC 9999999 VALUE ZERO.
               10  WEIGHTED-DEFI-NR     PIC 9999999 VALUE ZERO.
               10  MAX-LIMIT            PIC 9999999 VALUE ZERO.
               10  NR-NEW-METHODS       PIC S999999 VALUE ZERO.
               10  COMP-SUM             PIC 99V999  VALUE ZERO.
               10  QUAL-SUM             PIC 99V999  VALUE ZERO.
               10  COMPLEXITY           PIC 9V999   VALUE ZERO.
               10  QUALITY-RATING       PIC 9V999   VALUE ZERO.
               10  THIS-VALUE           PIC S9V999  VALUE ZERO.
               10  RATIO-VALUE          PIC 9.999   VALUE ZERO.
      *
           COPY METRICS.
      *
      ****************************************************************
      *    METRIC EXPORT TAGS
      ****************************************************************
      *
       01  XML-HEADER-LINES.
           05  XML-LINE             PIC X(72) VALUE
              '<?xml version="1.0" encoding="UTF-8" ?>'.
           05  DOC-LINE             PIC X(72) VALUE
              '<!--DOCTYPE IMETRICS SYSTEM "imetrics.xsd"-->'.
       01  METRIK-EXPORT-TAGS.
           05  FILE-TAGS.
               10  METRIC-TAG       PIC X(20) VALUE 'METRIC_FILE'.
               10  PRODUCT-ATTR     PIC X(20) VALUE 'Product'.
               10  VERSION-ATTR     PIC X(20) VALUE 'Version'.
               10  SYSTEM-ATTR      PIC X(20) VALUE 'System '.
               10  SENDER-ATTR      PIC X(20) VALUE 'Source '.
               10  DATE-ATTR        PIC X(20) VALUE 'Date   '.
           05  ENTITY-TAGS.
               10  ENTITY-TAG       PIC X(20) VALUE 'METRIC_ENTITY'.
               10  ENTITY-ATTR      PIC X(20) VALUE 'Entity'.
               10  NAME-ATTR        PIC X(20) VALUE 'EName'.
               10  TYPE-ATTR        PIC X(20) VALUE 'EType'.
           05  STRUCTURE-TAGS.
               10  QUANTITY-TAG     PIC X(20) VALUE 'Quantity_Metrics'.
               10  SOURCE-TAG       PIC X(20) VALUE 'Source_Metrics'.
               10  STRUCTURE-TAG   PIC X(20) VALUE 'Structural_Metrics'.
               10  DATA-TAG         PIC X(20) VALUE 'Data_Metrics'.
               10  DATAUSAGE-TAG    PIC X(20) VALUE 'DataUsage_Metrics'.
               10  PROC-TAG        PIC X(20) VALUE 'Procedural_Metrics'.
               10  INTER-TAG        PIC X(20) VALUE 'Interface_Metrics'.
               10  DEFI-TAG        PIC X(20) VALUE 'Deficiency_Metrics'.
               10  SIZE-TAG         PIC X(20) VALUE 'Size_Metrics'.
               10  COMPLEXITY-TAG  PIC X(20) VALUE 'Complexity_Metrics'.
               10  COMPLEXITIES-TAG PIC X(20) VALUE 'Complexities'.
               10  QUALITY-TAG      PIC X(20) VALUE 'Quality_Metrics'.
               10  QUALITIES-TAG    PIC X(20) VALUE 'Qualities'.
           05  QUANTITY-TAGS.
   ********** Source Metrics
               10  MEMBER-TAG       PIC X(20) VALUE 'Nr_Sources'.
               10  LINES-TAG        PIC X(20) VALUE 'Nr_Lines'.
               10  COMMENT-TAG      PIC X(20) VALUE 'Nr_Comment_Lines'.
               10  CODE-TAG         PIC X(20) VALUE 'Nr_Code_Lines'.
   ********** Structure Metrics
               10  MODULE-TAG       PIC X(20) VALUE 'Nr_Modules'.
               10  FILE-TAG         PIC X(20) VALUE 'Nr_Files'.
               10  PANEL-TAG        PIC X(20) VALUE 'Nr_Panels'.
               10  REPORT-TAG       PIC X(20) VALUE 'Nr_Reports'.
               10  INTERFACE-TAG    PIC X(20) VALUE 'Nr_Interfaces'.
               10  PARAM-TAG        PIC X(20) VALUE 'Nr_Params'.
               10  INPUT-TAG        PIC X(20) VALUE 'Nr_Inputs'.
               10  OUTPUT-TAG       PIC X(20) VALUE 'Nr_Outputs'.
               10  INCLUDE-TAG      PIC X(20) VALUE 'Nr_Includes'.
               10  CLASS-TAG        PIC X(20) VALUE 'Nr_Classes'.
             10 CLASSINHERIT-TAG PIC X(20) VALUE 'Nr_Classes_Inherited'.
               10  METHOD-TAG       PIC X(20) VALUE 'Nr_Operations'.
               10  CALL-TAG         PIC X(20) VALUE 'Nr_Calls'.
               10  STMT-TAG         PIC X(20) VALUE 'Nr_Stmts'.
               10  STMTTYPE-TAG     PIC X(20) VALUE 'Nr_Stmt_Types'.
               10  DATATYPE-TAG     PIC X(20) VALUE 'Nr_Data_Types'.
               10  TESTCASE-TAG     PIC X(20) VALUE 'Nr_TestCases'.
   **********  Data  Metrics
               10  STRUCTS-TAG      PIC X(20) VALUE 'Nr_Structures'.
               10  VARIABLE-TAG     PIC X(20) VALUE 'Nr_Attributes'.
               10  INIT-TAG         PIC X(20) VALUE 'Nr_Inits'.
               10  DEFINE-TAG       PIC X(20) VALUE 'Nr_Definitions'.
               10  DUPLICATE-TAG    PIC X(20) VALUE 'Nr_Duplicates'.
               10  ARRAY-TAG        PIC X(20) VALUE 'Nr_Arrays'.
               10  REDEF-TAG        PIC X(20) VALUE 'Nr_Redefines'.
   **********  Data Usage Metrics
               10  ARGUMENT-TAG     PIC X(20) VALUE 'Nr_Arguments'.
               10  RESULT-TAG       PIC X(20) VALUE 'Nr_Results'.
               10  PREDICATE-TAG    PIC X(20) VALUE 'Nr_Predicates'.
               10  PARAMETER-TAG    PIC X(20) VALUE 'Nr_Parameters'.
               10  REF-TAG          PIC X(20) VALUE 'Nr_References'.
               10  VIEW-TAG         PIC X(20) VALUE 'Nr_Views'.
   **********  Deficiencies
               10  MAJORDEFI-TAG    PIC X(20) VALUE 'Nr_Major_Defis'.
               10  MEDIADEFI-TAG    PIC X(20) VALUE 'Nr_Media_Defis'.
               10  MINORDEFI-TAG    PIC X(20) VALUE 'Nr_Minor_Defis'.
   **********  Sizes
               10  DATAPOINT-TAG    PIC X(20) VALUE 'Nr_Data_Points'.
               10  FUNCPOINT-TAG    PIC X(20) VALUE 'Nr_Func_Points'.
               10  OBJTPOINT-TAG    PIC X(20) VALUE 'Nr_Objt_Points'.
           05  COMPLEXITY-TAGS.
               10  DENSITY-TAG  PIC X(20) VALUE 'Density_Complexity'.
               10  RELATION-TAG PIC X(20) VALUE 'Relation_Complexity'.
               10  STRUC-TAG    PIC X(20) VALUE 'Structure_Complexity'.
               10  FORMAT-TAG    PIC X(20) VALUE 'Format_Complexity'.
               10  USAGECOMP-TAG PIC X(20) VALUE 'DataUsage_Complexity'.
               10  LANGUAGE-TAG  PIC X(20) VALUE 'Language_Complexity'.
               10  INTRCOMP-TAG  PIC X(20) VALUE 'Interface_Complexity'.
           05  OUALITY-TAGS.
               10  MODULARITY-TAG     PIC X(20) VALUE 'Modularity'.
               10  ADAPTABILITY-TAG   PIC X(20) VALUE 'Adaptability'.
               10  REUSABILITY-TAG    PIC X(20) VALUE 'Reusability'.
               10  TESTABILITY-TAG    PIC X(20) VALUE 'Testability'.
               10  PORTABILITY-TAG    PIC X(20) VALUE 'Portability'.
               10  CONFORMITY-TAG     PIC X(20) VALUE 'Conformity'.
               10  INTRQUAL-TAG  PIC X(20) VALUE 'Interface_Quality'.
      *
      ****************************************************************
      *
       LINKAGE SECTION.
      *
      ******************************************************************
      * "Dynamic linkage file names" (and others)
      ******************************************************************
      *
       77  FUNCT-CODE                        PIC XX.
       77  RET-CODE                          PIC XX.
       77  FILE-NAME                         PIC X(80).
           COPY EXPPARMS.
      ******************************************************************
      *    Basic Measurements Required
      ******************************************************************
      *
           COPY XMETTAB.
      *
           COPY OMETTAB.
      *
      ******************************************************************
      *
       PROCEDURE DIVISION USING FUNCT-CODE,
                                RET-CODE,
                                FILE-NAME,
                                EXPORT-DATA,
                                METR-TAB,
                                METRIC-TAB.
      *
      ******************************************************************
      *
       SOFTMESS-CONTROL SECTION.
      *
      ******************************************************************
      *
      * Produce the metric export file for PC-MESS
      *
      ******************************************************************
       SOFTMESS-CONTROLS.
      *
           MOVE ZEROES TO COMP-QUAL-METRICS.
           MOVE ZEROES TO WORK-METRICS.
           PERFORM OPEN-METRIC-EXPORT.
           PERFORM WRITE-FILE-HEADER.
           PERFORM WRITE-ENTITY-HEADER.
           PERFORM SOFTMESS-CALCULATION
           PERFORM WRITE-ENTITY-METRICS.
           PERFORM CLOSE-METRIC-EXPORT.
           MOVE ZEROS TO RET-CODE.
      *
           GOBACK.
      *
      ******************************************************************
      *
       SOFTMESS-OUTPUT SECTION.
      *
      ******************************************************************
      *
       OPEN-METRIC-EXPORT.
      *
      ******************************************************************
      *
      *  Open the Export File
      *
      ******************************************************************
      *
           MOVE FILE-NAME TO MESS-FILE-NAME
           MOVE ZEROES TO MESS-FSTS
           DISPLAY '| OBJMESS Version 3.2 of July 2007 '
           DISPLAY '| SoftMess Export File  = ' MESS-FILE-NAME.
           OPEN OUTPUT MESS-FILE.
      *
      ************************
      *
       WRITE-FILE-HEADER.
      *
      ******************************************************************
      *
      *  Create Metric Header
      *
      ******************************************************************
      *
      *                               Set up Header Info
      *
           MOVE XML-LINE TO MESS-REC
           WRITE MESS-REC.
           MOVE DOC-LINE TO MESS-REC
           WRITE MESS-REC.
           MOVE 'IMETRICS' TO CURRENT-TAG.
           PERFORM WRITE-FIRST-LEVEL-START.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE PRODUCT-ATTR TO CURRENT-TAG
           MOVE EXPORT-PRODUCT-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
SN0611     MOVE VERSION-ATTR TO CURRENT-TAG
           MOVE EXPORT-VERSION-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SYSTEM-ATTR TO CURRENT-TAG
           MOVE EXPORT-SYSTEM-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           ACCEPT YYMMDD FROM DATE
           MOVE YY TO JAHR
           MOVE MM TO MON
           MOVE DD TO TAG
           MOVE DATE-ATTR TO CURRENT-TAG
           MOVE DATUM TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SENDER-ATTR TO CURRENT-TAG
           MOVE EXPORTEUR TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-FILE-HEADER-END.
      *
      ******************************************************************
      *
       WRITE-ENTITY-HEADER.
      *
      ******************************************************************
      *
      *  Write out Entity Header
      *
      ******************************************************************
      *
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE ENTITY-TYPE TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE ENTITY-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE ENTITY-LANG TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
      *
      ******************************************************************
      *
       WRITE-ENTITY-METRICS.
      *
      ******************************************************************
      *
      *  Write out all Entity Metrics
      *
      ******************************************************************
      ******************************************* Start of Quantity
           MOVE QUANTITY-TAG      TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Source Metrics
           MOVE SOURCE-TAG        TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Sources
           MOVE MEMBER-TAG        TO CURRENT-TAG
           MOVE NR-SOURCES        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Lines
           MOVE LINES-TAG         TO CURRENT-TAG
           MOVE NR-LINES          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Code Lines
           MOVE CODE-TAG          TO CURRENT-TAG
           MOVE NR-CODE-LINES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Commentar Lines
           MOVE COMMENT-TAG       TO CURRENT-TAG
           MOVE NR-COMMENT-LINES  TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE SOURCE-TAG        TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Structural Metrics
           MOVE STRUCTURE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Modules
           MOVE MODULE-TAG        TO CURRENT-TAG
           MOVE NR-MODULES        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Files
           MOVE FILE-TAG          TO CURRENT-TAG
           MOVE NR-FILES          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Panels
           MOVE PANEL-TAG         TO CURRENT-TAG
           MOVE NR-PANELS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Reports
           MOVE REPORT-TAG        TO CURRENT-TAG
           MOVE NR-REPORTS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Interfaces
           MOVE INTERFACE-TAG     TO CURRENT-TAG
           MOVE NR-INTERFACES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Params
           MOVE PARAM-TAG         TO CURRENT-TAG
           MOVE NR-PARAMETERS     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Inputs
           MOVE INPUT-TAG         TO CURRENT-TAG
           MOVE NR-INPUTS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Outputs
           MOVE OUTPUT-TAG        TO CURRENT-TAG
           MOVE NR-OUTPUTS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Includes
           MOVE INCLUDE-TAG       TO CURRENT-TAG
           MOVE NR-INCLUDES       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Classes
           MOVE CLASS-TAG         TO CURRENT-TAG
           MOVE NR-CLASSES        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Operations
           MOVE METHOD-TAG        TO CURRENT-TAG
           MOVE NR-METHODS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Calls
           MOVE CALL-TAG          TO CURRENT-TAG
           MOVE NR-FUNCTION-CALLS TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Statements
           MOVE STMT-TAG          TO CURRENT-TAG
           MOVE NR-STMTS          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Stmt-Types
           MOVE STMTTYPE-TAG      TO CURRENT-TAG
           MOVE NR-STMT-TYPES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Data-Types
           MOVE DATATYPE-TAG      TO CURRENT-TAG
           MOVE NR-DATA-TYPES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * TestCases
           MOVE TESTCASE-TAG      TO CURRENT-TAG
           MOVE NR-TESTCASES      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE STRUCTURE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Data Metrics
           MOVE DATA-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Structures
           MOVE STRUCTS-TAG       TO CURRENT-TAG
           MOVE NR-STRUCTURES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Attributes
           MOVE VARIABLE-TAG      TO CURRENT-TAG
           MOVE NR-VARIABLES      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Inits/Constants
           MOVE INIT-TAG          TO CURRENT-TAG
           MOVE NR-CONSTANTS      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Definitions
           MOVE DEFINE-TAG        TO CURRENT-TAG
           MOVE NR-DEFINES        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Arrays
           MOVE ARRAY-TAG         TO CURRENT-TAG
           MOVE NR-ARRAYS         TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Redefinitions
           MOVE REDEF-TAG         TO CURRENT-TAG
           MOVE NR-REDEFINES      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Views
           MOVE VIEW-TAG          TO CURRENT-TAG
           MOVE NR-VIEWS          TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DATA-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* DataUsage Metrics
           MOVE DATAUSAGE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Arguments
           MOVE ARGUMENT-TAG      TO CURRENT-TAG
           MOVE NR-ARGUMENTS      TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Results
           MOVE RESULT-TAG        TO CURRENT-TAG
           MOVE NR-RESULTS        TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Predicates
           MOVE PREDICATE-TAG     TO CURRENT-TAG
           MOVE NR-PREDICATES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Parameters
           MOVE PARAMETER-TAG     TO CURRENT-TAG
           MOVE NR-PARAMETERS     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * References
           MOVE REF-TAG           TO CURRENT-TAG
           MOVE NR-REFERENCES     TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DATAUSAGE-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Deficiency Metrics
           MOVE DEFI-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Major Deficiencies
           MOVE MAJORDEFI-TAG     TO CURRENT-TAG
           MOVE NR-MAJOR-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Medium Deficiencies
           MOVE MEDIADEFI-TAG     TO CURRENT-TAG
           MOVE NR-MEDIA-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Minor Deficiencies
           MOVE MINORDEFI-TAG     TO CURRENT-TAG
           MOVE NR-MINOR-DEFIS    TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE DEFI-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ******************************************* Size Metrics
           MOVE SIZE-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Data Points
           MOVE DATAPOINT-TAG     TO CURRENT-TAG
           MOVE DATA-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Object Points
           MOVE OBJTPOINT-TAG     TO CURRENT-TAG
           MOVE OBJT-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
      * Function Points
           MOVE FUNCPOINT-TAG     TO CURRENT-TAG
           MOVE FUNC-POINTS       TO DISPLAY-VALUE
           MOVE DISPLAY-VALUE     TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA.
           MOVE SIZE-TAG          TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Quantity
           MOVE QUANTITY-TAG      TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ******************************************* Start of Complexity
           MOVE COMPLEXITY-TAG    TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Complexity Metrics
           MOVE COMPLEXITIES-TAG  TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Density
           MOVE DENSITY-TAG       TO CURRENT-TAG
           MOVE DATA-COMP         TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Relational Complexity
           MOVE RELATION-TAG      TO CURRENT-TAG
           MOVE DATA-RELA-COMP    TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Structural Complexity
           MOVE STRUC-TAG         TO CURRENT-TAG
           MOVE STRUCT-COMP       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Format     Complexity
           MOVE FORMAT-TAG        TO CURRENT-TAG
           MOVE FORMAT-COMP       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Data Flow  Complexity
           MOVE USAGECOMP-TAG     TO CURRENT-TAG
           MOVE DAT-FLOW-COMP     TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Language   Complexity
           MOVE LANGUAGE-TAG      TO CURRENT-TAG
           MOVE LANG-COMP         TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Interface  Complexity
           MOVE INTRCOMP-TAG      TO CURRENT-TAG
           MOVE PROG-COMPLEXITY   TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE COMPLEXITIES-TAG  TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Complexity
           MOVE COMPLEXITY-TAG    TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ******************************************* Start of Quality
           MOVE QUALITY-TAG       TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
      ******************************************* Quality Metrics
           MOVE QUALITIES-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-START.
      * Modularity
           MOVE MODULARITY-TAG    TO CURRENT-TAG
           MOVE MODULARITY        TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Adaptability
           MOVE ADAPTABILITY-TAG  TO CURRENT-TAG
           MOVE ADAPTABILITY      TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Reusability
           MOVE REUSABILITY-TAG   TO CURRENT-TAG
           MOVE REUSABILITY       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Testability
           MOVE TESTABILITY-TAG   TO CURRENT-TAG
           MOVE TESTABILITY       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Portability
           MOVE PORTABILITY-TAG   TO CURRENT-TAG
           MOVE PORTABILITY       TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Conformity
           MOVE CONFORMITY-TAG    TO CURRENT-TAG
           MOVE CONFORMITY        TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
      * Interface Quality
           MOVE INTRQUAL-TAG      TO CURRENT-TAG
           MOVE QUALITY-RATING    TO RATIO-VALUE
           MOVE RATIO-VALUE       TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-RATIO.
           MOVE QUALITIES-TAG     TO CURRENT-TAG
           PERFORM WRITE-FOURTH-LEVEL-END.
      ************************************************ End of Quality
           MOVE QUALITY-TAG       TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END.
      ************************************************ End of Entity
      *
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
      *
      ******************************************************************
      *
       CLOSE-METRIC-EXPORT.
      *
      ******************************************************************
      *
      *  Close the Export File
      *
      ******************************************************************
      *
           MOVE 'IMETRICS' TO CURRENT-TAG
           PERFORM WRITE-FIRST-LEVEL-END.
           CLOSE  MESS-FILE.
      ****************************************************************
       WRITE-XML SECTION.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING ' <'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING ' </'             DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '   <'            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '" >'             DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '   </'           DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 2nd Level
       WRITE-FILE-HEADER-END.
           MOVE SPACES TO MESS-REC.
           MOVE   '   />'  TO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '     <'          DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-ATTR.
           MOVE SPACES TO MESS-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '     </'         DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 4th Level
       WRITE-FOURTH-LEVEL-START.
           MOVE SPACES TO MESS-REC.
           STRING '       <'        DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 4th Level
       WRITE-FOURTH-LEVEL-END.
           MOVE SPACES TO MESS-REC.
           STRING '       </'       DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 5th Level
       WRITE-FIFTH-LEVEL-DATA.
           MOVE SPACES TO MESS-REC.
           STRING '         <'      DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
                   CURRENT-VALUE    DELIMITED BY SIZE
                  '</'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      ************************************************ 5th Level
       WRITE-FIFTH-LEVEL-RATIO.
           MOVE SPACES TO MESS-REC.
           STRING '         <'      DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
                   CURRENT-VALUE    DELIMITED BY SPACE
                  '</'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO MESS-REC.
           WRITE MESS-REC.
      *
      *****************************************************************
      *****************************************************************
      *
       SOFTMESS-CALCULATION SECTION.
      *
      *****************************************************************
      *
           COPY CALCXMET.
      *
      ******************* End of Source ********************************
