      ******************************************************************
      ******************************************************************
      *
XML    INITIALISATION  SECTION.
      *
      ******************************************************************
      *  Common Parameter Processing Routine
      ******************************************************************
      *
XML    READ-PARAM-FILE.
           MOVE ZEROES TO XML-STAT.
           PERFORM UNTIL XML-EOF
                      OR XML-LABEL = FILES
              READ PARAM-FILE
              AT END
                 MOVE '09' TO XML-STAT
              NOT AT END
                 MOVE PARAM-REC TO XML-LINE
                 PERFORM PARSE-XML
                 IF ERROR-CODE > ZERO
                    MOVE 2 TO ERROR-CODE
                 ELSE
                    EVALUATE TRUE
      ***      Names
                    WHEN XML-TYPE  = PRODUCTNAME
                       MOVE XML-ATTRB TO PRODUCT-NAME
                    WHEN XML-TYPE  = SYSTEMNAME
                       MOVE XML-ATTRB TO SYSTEM-NAME
      ***      Parameters
                    WHEN XML-TYPE  = LANGUAGE
                       MOVE XML-ATTRB TO AUDIT-LANGUAGE
                    WHEN XML-TYPE  = VERSION
                       MOVE XML-ATTRB TO AUDIT-VERSION
                    WHEN XML-TYPE  = AUDITCODE
                       MOVE XML-ATTRB TO AUDIT-CODE
                    WHEN XML-TYPE  = COMMENTCODE
                       MOVE XML-ATTRB TO COMMENT-CODE
                    WHEN XML-TYPE  = EXPORTCODE
                       MOVE XML-ATTRB TO REPO-CODE
                    WHEN XML-TYPE  = METRICS
                       MOVE XML-ATTRB TO METR-TAB
                    WHEN XML-TYPE  = SPECS
                       MOVE XML-ATTRB TO FILE-TAB
                    WHEN XML-TYPE  = RULES
                       MOVE XML-ATTRB TO RULE-TAB
      ***      Maximum Limits
                    WHEN XML-TYPE  = MAXCASES
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-CASES
                    WHEN XML-TYPE  = MAXPROCS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-PROCS
                    WHEN XML-TYPE  = MAXATTRS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-ATTRS
                    WHEN XML-TYPE  = MAXINPUTS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-INPUTS
                    WHEN XML-TYPE  = MAXOUTPUTS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-OUTPUTS
                    WHEN XML-TYPE  = MAXPARAMS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-PARAMS
                    WHEN XML-TYPE  = MAXACTIONS
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-ACTIONS
                    WHEN XML-TYPE  = MAXRULES
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-RULES
                    WHEN XML-TYPE  = MAXSTATES
                       MOVE XML-ATTRB TO ZAHL-CONVERT
                       PERFORM CONVERT
                       MOVE ZAHL-WERT TO MAX-STATES
      ***      Directories
                    WHEN XML-LABEL = INPUT-DIR-NAME
                       MOVE XML-VALUE TO INPUT-LIB-NAME
                    WHEN XML-LABEL = OUTPUT-DIR-NAME
                       MOVE XML-VALUE TO OUTPUT-LIB-NAME
                    WHEN XML-LABEL = WORK-DIR-NAME
                       MOVE XML-VALUE TO WORK-LIB-NAME
                    WHEN XML-LABEL = FUNCTAB-NAME
                       MOVE XML-VALUE TO FUNCTION-FILE-NAME
                    WHEN XML-LABEL = REPOTAB-NAME
                       MOVE XML-VALUE TO REPO-FILE-NAME
                    WHEN XML-LABEL = FILES
                       CONTINUE
                    WHEN OTHER
                       CONTINUE
                    END-EVALUATE
                 END-IF
              END-READ
           END-PERFORM.
      *    CLOSE PARAM-FILE.
           EXIT.
      *
      ******************************************************************
      ******************************************************************
      *
       RETURN-RESPONSE SECTION.
      *
      *************************************************************
      *   Open  XML File for Response                             *
      *************************************************************
      *
       OPEN-XML-FILE.
      *    Assign Name to output File and open output
           MOVE SPACES TO OUTPUT-FILE.
           STRING OUTPUT-LIB-NAME     DELIMITED BY SPACE
                 '/SOFTANAL.xml'      DELIMITED BY SIZE
              INTO OUTPUT-FILE.
           MOVE ZEROES TO OUTPUT-STAT.
           OPEN OUTPUT RESPONSE-FILE.
           IF OUTPUT-STAT NOT = ZEROES
              DISPLAY 'Response File could not be opened!!'
              DISPLAY 'File Path:' OUTPUT-FILE
           END-IF.
      *    Write XML Header Lines
           WRITE RESPONSE-REC FROM XML-HEADER-1
           WRITE RESPONSE-REC FROM XML-HEADER-2
           MOVE 'SOFTANAL' TO XML-FILE-NAME
      *    Write XML File Line
           MOVE SPACES TO RESPONSE-REC
           STRING ' <'                DELIMITED BY SIZE
                  XML-FILE-NAME       DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
              INTO RESPONSE-REC
           WRITE RESPONSE-REC.
TEST       DISPLAY 'XML Response File opened'.
      *
      ******************************************************************
      *  Set Error Message
      ******************************************************************
      *
       PROCESS-ERRORS.
      *
           EVALUATE ERROR-CODE
      **      Report no Error
           WHEN 0
              MOVE MSG-0 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'File:'                  DELIMITED BY SIZE
                     INPUT-LIB-NAME           DELIMITED BY SPACE
                INTO RETURN-MSG-2
      **      Report opening XML File
           WHEN 1
              MOVE MSG-1 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'File:'                  DELIMITED BY SIZE
                     XML-FILE                 DELIMITED BY SIZE
                INTO RETURN-MSG-2
      **      Report reading XML File
           WHEN 2
              MOVE MSG-2 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'Line:'                  DELIMITED BY SIZE
                     XML-LINE                 DELIMITED BY SIZE
                INTO RETURN-MSG-2
      **      Report Function Table not found
           WHEN 3
              MOVE MSG-3 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'File:'                  DELIMITED BY SIZE
                     FUNCTION-FILE-NAME       DELIMITED BY SPACE
                INTO RETURN-MSG-2
      **      Report Output Lib could not be found
           WHEN 4
              MOVE MSG-4 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'File:'                  DELIMITED BY SIZE
                     OUTPUT-LIB-NAME          DELIMITED BY SPACE
                INTO RETURN-MSG-2
      **      Input Source File could not be found
           WHEN 5
              MOVE MSG-5 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'File:'                  DELIMITED BY SIZE
                     INPUT-FILE               DELIMITED BY SPACE
                INTO RETURN-MSG-2
      **      Report error in reading source
           WHEN 6
              MOVE MSG-6 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'Line:'                  DELIMITED BY SIZE
                     CODE-LINE                DELIMITED BY SIZE
                INTO RETURN-MSG-2
      **      Report error in parsing source
           WHEN 7
              MOVE MSG-7 TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'Stmt:'                  DELIMITED BY SIZE
                     SOURCE-STMT              DELIMITED BY SIZE
                INTO RETURN-MSG-2
      **      Report Unknown error occurred
           WHEN OTHER
              MOVE MSG-9  TO RETURN-MSG-1
              MOVE SPACES TO RETURN-MSG-2
              STRING 'Stmt:'                  DELIMITED BY SIZE
                     SOURCE-STMT              DELIMITED BY SIZE
                INTO RETURN-MSG-2
           END-EVALUATE.
           EXIT.
      *************************************************************
      *   Write XML File for this Response                        *
      *************************************************************
      *
       WRITE-XML-FILE.
      *    Write XML Response
           MOVE SPACES TO RESPONSE-REC
           STRING '   <'              DELIMITED BY SIZE
                  XML-REC-NAME        DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
                  RETURN-MSG-1        DELIMITED BY SPACE
                  '</'                DELIMITED BY SIZE
                  XML-REC-NAME        DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
              INTO RESPONSE-REC
           WRITE RESPONSE-REC.
           MOVE SPACES TO RESPONSE-REC
           STRING '   <'              DELIMITED BY SIZE
                  XML-REC-NAME        DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
                  RETURN-MSG-2        DELIMITED BY SPACE
                  '</'                DELIMITED BY SIZE
                  XML-REC-NAME        DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
              INTO RESPONSE-REC
           WRITE RESPONSE-REC.
TEST       DISPLAY 'XML Response File written'.
      *
      *************************************************************
      *   Close XML File for this Response                        *
      *************************************************************
      *
       CLOSE-XML-FILE.
      *    Write XML End  Line
           MOVE SPACES TO RESPONSE-REC
           STRING ' </'               DELIMITED BY SIZE
                  XML-FILE-NAME       DELIMITED BY SPACE
                  '>'                 DELIMITED BY SIZE
              INTO RESPONSE-REC
           WRITE RESPONSE-REC
           CLOSE RESPONSE-FILE.
TEST       DISPLAY 'XML Response File closed'.
TEST       DISPLAY 'SoftAnal terminated!'
TEST       ACCEPT CONTINUE-KEY.
      *
      ******************************************************************
      ******************************************************************
      *
XML    XML-PARSING SECTION.
      *
      ******************************************************************
      *  Common XML Parameters Parsing Routine
      ******************************************************************
      *
XML        COPY XMLPARSE.cpy.
      *
      ******************************************************************
      ******************************************************************
      *
XML    CONVERT SECTION.
      *
      ******************************************************************
      *  Common Parameter Conversion Routine
      ******************************************************************
      *
       A-CONVERT.
           MOVE 4 TO XZ-1
           MOVE 4 TO XZ-2
           MOVE ZEROES TO ZAHL-WERT
           PERFORM UNTIL XZ-1 < 1
             PERFORM B-CONVERT
             SUBTRACT 1 FROM XZ-1
           END-PERFORM.
      *********** ASCII TO INTEGER ************
       B-CONVERT.
           EVALUATE C-WERT(XZ-1)
             WHEN '0'
               MOVE 0 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '1'
               MOVE 1 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '2'
               MOVE 2 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '3'
               MOVE 3 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '4'
               MOVE 4 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '5'
               MOVE 5 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '6'
               MOVE 6 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '7'
               MOVE 7 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '8'
               MOVE 8 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN '9'
               MOVE 9 TO Z-WERT(XZ-2)
               SUBTRACT 1 FROM XZ-2
             WHEN OTHER
               CONTINUE
           END-EVALUATE
           EXIT.
      ********************** end of source *****************************
